@inject Waiter wagter
@inject Observatory obz
@implements IDisposable

<button type="button" class="btn btn-primary" disabled="@buttonDisabled" @onclick="OnClickCallback">
    @if (isSpinning) {
        <div class="spinner-border spinner-border-sm" role="status">
            <span class="sr-only">Loading...</span>
        </div>
    }else{
        @ChildContent
    }
</button>


@code {

    [Parameter]
    public RenderFragment ChildContent { get; set; }

    [Parameter]
    public string SpinningKey {get;set;}

    private bool buttonDisabled => isSpinning || isDisabled;
    private bool isSpinning {get; set;} = false;
    private bool isDisabled {get; set;} = false;

    [Parameter]
    public EventCallback<MouseEventArgs> OnClickCallback { get; set; }

    protected override void OnInitialized() {
        isDisabled = wagter.isBusy();
        isSpinning = wagter.GetState(SpinningKey);

        obz.Register<bool>("isBusyChanged", (bool isBusy)=>{
            this.isDisabled=isBusy;
            base.StateHasChanged();
        }, $"SpinButton_{SpinningKey}");
        obz.Register<bool>($"stateChanged_{SpinningKey}", (bool newState)=>{
            this.isSpinning=newState;
            base.StateHasChanged();
        }, $"SpinButton_{SpinningKey}");
    }

    public void Dispose(){
        obz.Deregister($"SpinButton_{SpinningKey}");
    }
}